Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 1)
@@ -394,153 +360,173 @@
        nysf(j)   = j * nny
        nynf(j)   = ( j + 1 ) * nny - 1
+       nny_pe(j) = MIN( ny, nynf(j) ) - nysf(j) + 1
     ENDDO
 
 !
 !-- Local array bounds of the respective PEs
-    nxl = nxlf(pcoord(1))
-    nxr = nxrf(pcoord(1))
-    nys = nysf(pcoord(2))
-    nyn = nynf(pcoord(2))
-    nzb = 0
-    nzt = nz
-    nnz = nz
-
-!
-!-- Set switches to define if the PE is situated at the border of the virtual processor grid
-    IF ( nxl == 0 )   left_border_pe  = .TRUE.
-    IF ( nxr == nx )  right_border_pe = .TRUE.
-    IF ( nys == 0 )   south_border_pe = .TRUE.
-    IF ( nyn == ny )  north_border_pe = .TRUE.
-
-!
-!-- Calculate array bounds and gridpoint numbers for the transposed arrays (needed in the pressure
-!-- solver)
-!-- For the transposed arrays, cyclic boundaries as well as top and bottom boundaries are omitted,
-!-- because they are obstructive to the transposition
+    nxl  = nxlf(pcoord(1))
+    nxra = nxrf(pcoord(1))
+    nxr  = MIN( nx, nxra )
+    nys  = nysf(pcoord(2))
+    nyna = nynf(pcoord(2))
+    nyn  = MIN( ny, nyna )
+    nzb  = 0
+    nzta = nza
+    nzt  = MIN( nz, nzta )
+    nnz  = nza
+
+!
+!-- Calculate array bounds and gridpoint numbers for the transposed arrays
+!-- (needed in the pressure solver)
+!-- For the transposed arrays, cyclic boundaries as well as top and bottom
+!-- boundaries are omitted, because they are obstructive to the transposition
 
 !
 !-- 1. transposition  z --> x
-!-- This transposition is not neccessary in case of a 1d-decomposition along x
-    IF ( psolver == 'poisfft'  .OR.  calculate_spectra )  THEN
-
-       IF ( pdims(2) /= 1 )  THEN
-          IF ( MOD( nz , pdims(1) ) /= 0 )  THEN
-             WRITE( message_string, * ) 'transposition z --> x:& ',                                &
-                                        'nz=', nz, ' is not an integral multiple ',                &
-                                        'of pdims(1)=', pdims(1)
-             CALL message( 'init_pegrid', 'PA0230', 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDIF
-
-       nys_x = nys
-       nyn_x = nyn
-       nny_x = nny
-       nnz_x = nz / pdims(1)
-       nzb_x = 1 + myidx * nnz_x
-       nzt_x = ( myidx + 1 ) * nnz_x
+!-- This transposition is not neccessary in case of a 1d-decomposition along x,
+!-- except that the uptream-spline method is switched on
+    IF ( pdims(2) /= 1  .OR.  momentum_advec == 'ups-scheme'  .OR. &
+         scalar_advec == 'ups-scheme' )  THEN
+
+       IF ( pdims(2) == 1  .AND. ( momentum_advec == 'ups-scheme'  .OR. &
+            scalar_advec == 'ups-scheme' ) )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*,'+++ WARNING: init_pegrid: 1d-decomposition along x ', &
+                                &'chosen but nz restrictions may occur'
+             PRINT*,'             since ups-scheme is activated'
+          ENDIF
+       ENDIF
+       nys_x  = nys
+       nyn_xa = nyna
+       nyn_x  = nyn
+       nny_x  = nny
+       IF ( MOD( nza , pdims(1) ) /= 0 )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*,'+++ transposition z --> x:'
+             PRINT*,'    nz=',nz,' is not an integral divisior of pdims(1)=', &
+                    &pdims(1)
+          ENDIF
+          CALL local_stop
+       ENDIF
+       nnz_x  = nza / pdims(1)
+       nzb_x  = 1 + myidx * nnz_x
+       nzt_xa = ( myidx + 1 ) * nnz_x
+       nzt_x  = MIN( nzt, nzt_xa )
+
        sendrecvcount_zx = nnx * nny * nnz_x
 
     ENDIF
 
-
-    IF ( psolver == 'poisfft' )  THEN
-!
-!--    2. transposition  x --> y
-       IF ( MOD( nx+1 , pdims(2) ) /= 0 )  THEN
-          WRITE( message_string, * ) 'transposition x --> y:& ',                                   &
-                                     'nx+1=', nx+1, ' is not an integral ',                        &
-                                     'multiple of pdims(2)=', pdims(2)
-          CALL message( 'init_pegrid', 'PA0231', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       nnz_y = nnz_x
-       nzb_y = nzb_x
-       nzt_y = nzt_x
-       nnx_y = (nx+1) / pdims(2)
-       nxl_y = myidy * nnx_y
-       nxr_y = ( myidy + 1 ) * nnx_y - 1
-       sendrecvcount_xy = nnx_y * nny_x * nnz_y
-!
-!--    3. transposition  y --> z
-!--    (ELSE:  x --> y  in case of 1D-decomposition along x)
-       nxl_z = nxl_y
-       nxr_z = nxr_y
-       nny_z = (ny+1) / pdims(1)
-       nys_z = myidx * nny_z
-       nyn_z = ( myidx + 1 ) * nny_z - 1
+!
+!-- 2. transposition  x --> y
+    nnz_y  = nnz_x
+    nzb_y  = nzb_x
+    nzt_ya = nzt_xa
+    nzt_y  = nzt_x
+    IF ( MOD( nxa+1 , pdims(2) ) /= 0 )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*,'+++ transposition x --> y:'
+          PRINT*,'    nx+1=',nx+1,' is not an integral divisor of ',&
+                 &'pdims(2)=',pdims(2)
+       ENDIF
+       CALL local_stop
+    ENDIF
+    nnx_y = (nxa+1) / pdims(2)
+    nxl_y = myidy * nnx_y
+    nxr_ya = ( myidy + 1 ) * nnx_y - 1
+    nxr_y  = MIN( nx, nxr_ya )
+
+    sendrecvcount_xy = nnx_y * nny_x * nnz_y
+
+!
+!-- 3. transposition  y --> z  (ELSE:  x --> y  in case of 1D-decomposition
+!-- along x)
+    IF ( pdims(2) /= 1  .OR.  momentum_advec == 'ups-scheme'  .OR. &
+         scalar_advec == 'ups-scheme' )  THEN
+!
+!--    y --> z
+!--    This transposition is not neccessary in case of a 1d-decomposition
+!--    along x, except that the uptream-spline method is switched on
+       nnx_z  = nnx_y
+       nxl_z  = nxl_y
+       nxr_za = nxr_ya
+       nxr_z  = nxr_y
+       IF ( MOD( nya+1 , pdims(1) ) /= 0 )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*,'+++ Transposition y --> z:'
+             PRINT*,'    ny+1=',ny+1,' is not an integral divisor of ',&
+                    &'pdims(1)=',pdims(1)
+          ENDIF
+          CALL local_stop
+       ENDIF
+       nny_z  = (nya+1) / pdims(1)
+       nys_z  = myidx * nny_z
+       nyn_za = ( myidx + 1 ) * nny_z - 1
+       nyn_z  = MIN( ny, nyn_za )
+
        sendrecvcount_yz = nnx_y * nny_z * nnz_y
 
-       IF ( pdims(2) /= 1 )  THEN
-!
-!--       y --> z
-!--       This transposition is not neccessary in case of a 1d-decomposition
-!--       along x, except that the uptream-spline method is switched on
-          IF ( MOD( ny+1 , pdims(1) ) /= 0 )  THEN
-             WRITE( message_string, * ) 'transposition y --> z:& ',                                &
-                                        'ny+1=', ny+1, ' is not an integral ',                     &
-                                        'multiple of pdims(1)=', pdims(1)
-             CALL message( 'init_pegrid', 'PA0232', 1, 2, 0, 6, 0 )
-          ENDIF
-
+    ELSE
+!
+!--    x --> y. This condition must be fulfilled for a 1D-decomposition along x
+       IF ( MOD( nya+1 , pdims(1) ) /= 0 )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*,'+++ Transposition x --> y:'
+             PRINT*,'    ny+1=',ny+1,' is not an integral divisor of ',&
+                    &'pdims(1)=',pdims(1)
+          ENDIF
+          CALL local_stop
+       ENDIF
+
+    ENDIF
+
+!
+!-- Indices for direct transpositions z --> y (used for calculating spectra)
+    IF ( dt_dosp /= 9999999.9 )  THEN
+       IF ( MOD( nza, pdims(2) ) /= 0 )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*,'+++ Direct transposition z --> y (needed for spectra):'
+             PRINT*,'    nz=',nz,' is not an integral divisor of ',&
+                    &'pdims(2)=',pdims(2)
+          ENDIF
+          CALL local_stop
        ELSE
-!
-!--       x --> y
-!--       This condition must be fulfilled for a 1D-decomposition along x
-          IF ( MOD( ny+1 , pdims(1) ) /= 0 )  THEN
-             WRITE( message_string, * ) 'transposition x --> y:& ',                                &
-                                        'ny+1=', ny+1, ' is not an integral ',                     &
-                                        'multiple of pdims(1)=', pdims(1)
-             CALL message( 'init_pegrid', 'PA0233', 1, 2, 0, 6, 0 )
-          ENDIF
-
-       ENDIF
-
-    ENDIF
-
-!
-!-- Indices for direct transpositions z --> y (used for calculating spectra)
-    IF ( calculate_spectra )  THEN
-       IF ( MOD( nz, pdims(2) ) /= 0 )  THEN
-          WRITE( message_string, * ) 'direct transposition z --> y (needed ',                      &
-                                     'for spectra):& nz=', nz, ' is not an ',                      &
-                                     'integral multiple of pdims(2)=', pdims(2)
-          CALL message( 'init_pegrid', 'PA0234', 1, 2, 0, 6, 0 )
-       ELSE
-          nxl_yd = nxl
-          nxr_yd = nxr
-          nzb_yd = 1 + myidy * ( nz / pdims(2) )
-          nzt_yd = ( myidy + 1 ) * ( nz / pdims(2) )
-          sendrecvcount_zyd = nnx * nny * ( nz / pdims(2) )
-       ENDIF
-    ENDIF
-
-    IF ( psolver == 'poisfft'  .OR.  calculate_spectra )  THEN
-!
-!--    Indices for direct transpositions y --> x
-!--    (they are only possible in case of a 1d-decomposition along x)
-       IF ( pdims(2) == 1 )  THEN
-          nny_x = nny / pdims(1)
-          nys_x = myid * nny_x
-          nyn_x = ( myid + 1 ) * nny_x - 1
-          nzb_x = 1
-          nzt_x = nz
-          sendrecvcount_xy = nnx * nny_x * nz
-       ENDIF
-
-    ENDIF
-
-    IF ( psolver == 'poisfft' )  THEN
-!
-!--    Indices for direct transpositions x --> y
-!--    (they are only possible in case of a 1d-decomposition along y)
-       IF ( pdims(1) == 1 )  THEN
-          nnx_y = nnx / pdims(2)
-          nxl_y = myid * nnx_y
-          nxr_y = ( myid + 1 ) * nnx_y - 1
-          nzb_y = 1
-          nzt_y = nz
-          sendrecvcount_xy = nnx_y * nny * nz
-       ENDIF
-
+          nxl_yd  = nxl
+          nxr_yda = nxra
+          nxr_yd  = nxr
+          nzb_yd  = 1 + myidy * ( nza / pdims(2) )
+          nzt_yda = ( myidy + 1 ) * ( nza / pdims(2) )
+          nzt_yd  = MIN( nzt, nzt_yda )
+
+          sendrecvcount_zyd = nnx * nny * ( nza / pdims(2) )
+       ENDIF
+    ENDIF
+
+!
+!-- Indices for direct transpositions y --> x (they are only possible in case
+!-- of a 1d-decomposition along x)
+    IF ( pdims(2) == 1 )  THEN
+       nny_x  = nny / pdims(1)
+       nys_x  = myid * nny_x
+       nyn_xa = ( myid + 1 ) * nny_x - 1
+       nyn_x  = MIN( ny, nyn_xa )
+       nzb_x  = 1
+       nzt_xa = nza
+       nzt_x  = nz
+       sendrecvcount_xy = nnx * nny_x * nza
+    ENDIF
+
+!
+!-- Indices for direct transpositions x --> y (they are only possible in case
+!-- of a 1d-decomposition along y)
+    IF ( pdims(1) == 1 )  THEN
+       nnx_y  = nnx / pdims(2)
+       nxl_y  = myid * nnx_y
+       nxr_ya = ( myid + 1 ) * nnx_y - 1
+       nxr_y  = MIN( nx, nxr_ya )
+       nzb_y  = 1
+       nzt_ya = nza
+       nzt_y  = nz
+       sendrecvcount_xy = nnx_y * nny * nza
     ENDIF
 
@@ -548,35 +534,4 @@
 !-- Arrays for storing the array bounds are needed any more
     DEALLOCATE( nxlf , nxrf , nynf , nysf )
-
-
-!
-!-- Collect index bounds from other PEs (to be written to restart file later)
-    ALLOCATE( hor_index_bounds(4,0:numprocs-1) )
-
-    IF ( myid == 0 )  THEN
-
-       hor_index_bounds(1,0) = nxl
-       hor_index_bounds(2,0) = nxr
-       hor_index_bounds(3,0) = nys
-       hor_index_bounds(4,0) = nyn
-
-!
-!--    Receive data from all other PEs
-       DO  i = 1, numprocs-1
-          CALL MPI_RECV( ibuf, 4, MPI_INTEGER, i, MPI_ANY_TAG, comm2d, status, ierr )
-          hor_index_bounds(:,i) = ibuf(1:4)
-       ENDDO
-
-    ELSE
-!
-!--    Send index bounds to PE0
-       ibuf(1) = nxl
-       ibuf(2) = nxr
-       ibuf(3) = nys
-       ibuf(4) = nyn
-       CALL MPI_SEND( ibuf, 4, MPI_INTEGER, 0, myid, comm2d, ierr )
-
-    ENDIF
-
 
 #if defined( __print )
@@ -586,14 +541,18 @@
        PRINT*, '*** processor topology ***'
        PRINT*, ' '
-       PRINT*, 'myid   pcoord    left right  south north  idx idy   nxl: nxr','   nys: nyn'
-       PRINT*, '------------------------------------------------------------','-----------'
-       WRITE (*,1000)  0, pcoord(1), pcoord(2), pleft, pright, psouth, pnorth, myidx, myidy, nxl,  &
-                       nxr, nys, nyn
-1000   FORMAT (I4,2X,'(',I3,',',I3,')',3X,I4,2X,I4,3X,I4,2X,I4,2X,I3,1X,I3,2(2X,I4,':',I4))
-
-!
-!--    Receive data from the other PEs
+       PRINT*, 'myid   pcoord    left right  south north  idx idy   nxl: nxr',&
+               &'   nys: nyn'
+       PRINT*, '------------------------------------------------------------',&
+               &'-----------'
+       WRITE (*,1000)  0, pcoord(1), pcoord(2), pleft, pright, psouth, pnorth, &
+                       myidx, myidy, nxl, nxr, nys, nyn
+1000   FORMAT (I4,2X,'(',I3,',',I3,')',3X,I4,2X,I4,3X,I4,2X,I4,2X,I3,1X,I3, &
+               2(2X,I4,':',I4))
+
+!
+!--    Recieve data from the other PEs
        DO  i = 1,numprocs-1
-          CALL MPI_RECV( ibuf, 12, MPI_INTEGER, i, MPI_ANY_TAG, comm2d, status, ierr )
+          CALL MPI_RECV( ibuf, 12, MPI_INTEGER, i, MPI_ANY_TAG, comm2d, status, &
+                         ierr )
           WRITE (*,1000)  i, ( ibuf(j) , j = 1,12 )
        ENDDO
@@ -606,171 +565,61 @@
        ibuf(8) = myidy; ibuf(9) = nxl; ibuf(10) = nxr; ibuf(11) = nys
        ibuf(12) = nyn
-       CALL MPI_SEND( ibuf, 12, MPI_INTEGER, 0, myid, comm2d, ierr )
+       CALL MPI_SEND( ibuf, 12, MPI_INTEGER, 0, myid, comm2d, ierr )       
     ENDIF
 #endif
 
-!
-!-- Determine the number of ghost point layers
-    IF ( scalar_advec   == 'ws-scheme'  .OR.                                                       &
-         momentum_advec == 'ws-scheme'  .OR.  nested_run )  THEN
-       nbgp = 3
-    ELSE
-       nbgp = 1
-    ENDIF
-
-!
-!-- Check that the number of computational grid points is not smaller than the number of ghost
-!-- points.
-    IF ( nnx < nbgp )  THEN
-       WRITE( message_string, * ) 'number of subdomain grid points along x (', nnx, ') is smaller',&
-                                  'than the number of ghost points (', nbgp, ')'
-       CALL message( 'init_pegrid', 'PA0682', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( nny < nbgp )  THEN
-       WRITE( message_string, * ) 'number of subdomain grid points along y (', nny, ') is smaller',&
-                                  'than the number of ghost points (', nbgp, ')'
-       CALL message( 'init_pegrid', 'PA0683', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Create a new MPI derived datatype for the exchange of surface (xy) data, which is needed for
-!-- coupled atmosphere-ocean runs.
-!-- First, calculate number of grid points of an xy-plane.
-    ngp_xy  = ( nxr - nxl + 1 + 2 * nbgp ) * ( nyn - nys + 1 + 2 * nbgp )
-    CALL MPI_TYPE_VECTOR( ngp_xy, 1, nzt-nzb+2, MPI_REAL, type_xy, ierr )
-    CALL MPI_TYPE_COMMIT( type_xy, ierr )
-
-    IF ( TRIM( coupling_mode ) /= 'uncoupled' )  THEN
-
-!
-!--    Pass the number of grid points of the atmosphere model to
-!--    the ocean model and vice versa
-       IF ( coupling_mode == 'atmosphere_to_ocean' )  THEN
-
-          nx_a = nx
-          ny_a = ny
-
-          IF ( myid == 0 )  THEN
-
-             CALL MPI_SEND( nx_a, 1, MPI_INTEGER, numprocs, 1, comm_inter, ierr )
-             CALL MPI_SEND( ny_a, 1, MPI_INTEGER, numprocs, 2, comm_inter,  ierr )
-             CALL MPI_SEND( pdims, 2, MPI_INTEGER, numprocs, 3, comm_inter, ierr )
-             CALL MPI_RECV( nx_o, 1, MPI_INTEGER, numprocs, 4, comm_inter, status, ierr )
-             CALL MPI_RECV( ny_o, 1, MPI_INTEGER, numprocs, 5, comm_inter, status, ierr )
-             CALL MPI_RECV( pdims_remote, 2, MPI_INTEGER, numprocs, 6, comm_inter, status, ierr )
-          ENDIF
-
-          CALL MPI_BCAST( nx_o, 1, MPI_INTEGER, 0, comm2d, ierr )
-          CALL MPI_BCAST( ny_o, 1, MPI_INTEGER, 0, comm2d, ierr )
-          CALL MPI_BCAST( pdims_remote, 2, MPI_INTEGER, 0, comm2d, ierr )
-
-       ELSEIF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
-
-          nx_o = nx
-          ny_o = ny
-
-          IF ( myid == 0 )  THEN
-
-             CALL MPI_RECV( nx_a, 1, MPI_INTEGER, 0, 1, comm_inter, status, ierr )
-             CALL MPI_RECV( ny_a, 1, MPI_INTEGER, 0, 2, comm_inter, status, ierr )
-             CALL MPI_RECV( pdims_remote, 2, MPI_INTEGER, 0, 3, comm_inter, status, ierr )
-             CALL MPI_SEND( nx_o, 1, MPI_INTEGER, 0, 4, comm_inter, ierr )
-             CALL MPI_SEND( ny_o, 1, MPI_INTEGER, 0, 5, comm_inter, ierr )
-             CALL MPI_SEND( pdims, 2, MPI_INTEGER, 0, 6, comm_inter, ierr )
-          ENDIF
-
-          CALL MPI_BCAST( nx_a, 1, MPI_INTEGER, 0, comm2d, ierr)
-          CALL MPI_BCAST( ny_a, 1, MPI_INTEGER, 0, comm2d, ierr)
-          CALL MPI_BCAST( pdims_remote, 2, MPI_INTEGER, 0, comm2d, ierr)
-
-       ENDIF
-
-       ngp_a = ( nx_a+1 + 2 * nbgp ) * ( ny_a+1 + 2 * nbgp )
-       ngp_o = ( nx_o+1 + 2 * nbgp ) * ( ny_o+1 + 2 * nbgp )
-
-!
-!--    Determine if the horizontal grid and the number of PEs in ocean and atmosphere is same or not.
-       IF ( nx_o == nx_a  .AND.  ny_o == ny_a  .AND.                                               &
-            pdims(1) == pdims_remote(1)  .AND.  pdims(2) == pdims_remote(2) )  THEN
-          coupling_topology = 0
-       ELSE
-          coupling_topology = 1
-       ENDIF
-
-!
-!--    Determine the target PEs for the exchange between ocean and atmosphere (comm2d)
-       IF ( coupling_topology == 0 )  THEN
-!
-!--       In case of identical topologies, every atmosphere PE has exactly one ocean PE counterpart
-!--       and vice versa
-          IF ( TRIM( coupling_mode ) == 'atmosphere_to_ocean' )  THEN
-             target_id = myid + numprocs
-          ELSE
-             target_id = myid
-          ENDIF
-
-       ELSE
-!
-!--       In case of nonequivalent topology in ocean and atmosphere only for PE0 in ocean and PE0 in
-!--       atmosphere a target_id is needed, since data echxchange between ocean and atmosphere will
-!--       be done only between these PEs.
-          IF ( myid == 0 )  THEN
-
-             IF ( TRIM( coupling_mode ) == 'atmosphere_to_ocean' )  THEN
-                target_id = numprocs
-             ELSE
-                target_id = 0
-             ENDIF
-
-          ENDIF
-
-       ENDIF
-
-    ENDIF
-
 #else
 
 !
-!-- Array bounds when running on a single PE (respectively a non-parallel machine)
-    nxl = 0
-    nxr = nx
-    nnx = nxr - nxl + 1
-    nys = 0
-    nyn = ny
-    nny = nyn - nys + 1
-    nzb = 0
-    nzt = nz
-    nnz = nz
-
-    ALLOCATE( hor_index_bounds(4,0:0) )
-    hor_index_bounds(1,0) = nxl
-    hor_index_bounds(2,0) = nxr
-    hor_index_bounds(3,0) = nys
-    hor_index_bounds(4,0) = nyn
-
-!
-!-- Array bounds for the pressure solver (in the parallel code, these bounds are the ones for the
-!-- transposed arrays)
-    nys_x = nys
-    nyn_x = nyn
-    nzb_x = nzb + 1
-    nzt_x = nzt
-
-    nxl_y = nxl
-    nxr_y = nxr
-    nzb_y = nzb + 1
-    nzt_y = nzt
-
-    nxl_z = nxl
-    nxr_z = nxr
-    nys_z = nys
-    nyn_z = nyn
+!-- Array bounds when running on a single PE (respectively a non-parallel
+!-- machine)
+    nxl  = 0
+    nxr  = nx
+    nxra = nx
+    nnx  = nxr - nxl + 1
+    nys  = 0
+    nyn  = ny
+    nyna = ny
+    nny  = nyn - nys + 1
+    nzb  = 0
+    nzt  = nz
+    nzta = nz
+    nnz  = nz
+
+!
+!-- For non-cyclic boundaries extend array u (v) by one gridpoint
+    IF ( bc_lr /= 'cyclic' )  uxrp = 1
+    IF ( bc_ns /= 'cyclic' )  vynp = 1
+
+!
+!-- Array bounds for the pressure solver (in the parallel code, these bounds
+!-- are the ones for the transposed arrays)
+    nys_x  = nys
+    nyn_x  = nyn
+    nyn_xa = nyn
+    nzb_x  = nzb + 1
+    nzt_x  = nzt
+    nzt_xa = nzt
+
+    nxl_y  = nxl
+    nxr_y  = nxr
+    nxr_ya = nxr
+    nzb_y  = nzb + 1
+    nzt_y  = nzt
+    nzt_ya = nzt
+
+    nxl_z  = nxl
+    nxr_z  = nxr
+    nxr_za = nxr
+    nys_z  = nys
+    nyn_z  = nyn
+    nyn_za = nyn
 
 #endif
 
 !
-!-- Calculate number of grid levels necessary for the multigrid poisson solver as well as the
-!-- gridpoint indices on each level
-    IF ( psolver(1:9) == 'multigrid' )  THEN
+!-- Calculate number of grid levels necessary for the multigrid poisson solver
+!-- as well as the gridpoint indices on each level
+    IF ( psolver == 'multigrid' )  THEN
 
 !
@@ -792,43 +641,17 @@
        ENDDO
 
-       k = nz    ! do not use nnz because it might be > nz due to transposition
-                 ! requirements
+       k = nnz
        DO WHILE ( MOD( k, 2 ) == 0  .AND.  k /= 2 )
           k = k / 2
           mg_levels_z = mg_levels_z + 1
        ENDDO
-!
-!--    The optimized MG-solver does not allow odd values for nz at the coarsest grid level
-       IF ( TRIM( psolver ) /= 'multigrid_noopt' )  THEN
-          IF ( MOD( k, 2 ) /= 0 )  mg_levels_z = mg_levels_z - 1
-!
-!--       An odd value of nz does not work. The finest level must have an even value.
-          IF (  mg_levels_z == 0 )  THEN
-             message_string = 'optimized multigrid method requires nz to be even'
-             CALL message( 'init_pegrid', 'PA0495', 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDIF
 
        maximum_grid_level = MIN( mg_levels_x, mg_levels_y, mg_levels_z )
-!
-!--    Check if subdomain sizes prevents any coarsening.
-!--    This case, the maximum number of grid levels is 1, i.e. effectively a Gauss-Seidel scheme is
-!--    applied rather than a multigrid approach.
-!--    Give a warning in this case.
-       IF ( maximum_grid_level == 1  .AND.  mg_switch_to_pe0_level == -1 )  THEN
-          message_string = 'No grid coarsening possible, multigrid ' //                            &
-                           'approach effectively reduces to a Gauss-Seidel ' //                    &
-                           'scheme.'
-
-          CALL message( 'poismg', 'PA0648', 0, 1, 0, 6, 0 )
-       ENDIF
-
-!
-!--    Find out, if the total domain allows more levels. These additional levels are identically
-!--    processed on all PEs.
-       IF ( numprocs > 1  .AND.  mg_switch_to_pe0_level /= -1 )  THEN
-
+
+!
+!--    Find out, if the total domain allows more levels. These additional
+!--    levels are processed on PE0 only.
+       IF ( numprocs > 1 )  THEN
           IF ( mg_levels_z > MIN( mg_levels_x, mg_levels_y ) )  THEN
-
              mg_switch_to_pe0_level_l = maximum_grid_level
 
@@ -851,19 +674,19 @@
 
              IF ( maximum_grid_level_l > mg_switch_to_pe0_level_l )  THEN
-                mg_switch_to_pe0_level_l = maximum_grid_level_l - mg_switch_to_pe0_level_l + 1
+                mg_switch_to_pe0_level_l = maximum_grid_level_l - &
+                                           mg_switch_to_pe0_level_l + 1
              ELSE
                 mg_switch_to_pe0_level_l = 0
              ENDIF
-
           ELSE
-
              mg_switch_to_pe0_level_l = 0
              maximum_grid_level_l = maximum_grid_level
-
-          ENDIF
-
-!
-!--       Use switch level calculated above only if it is not pre-defined by user
+          ENDIF
+
+!
+!--       Use switch level calculated above only if it is not pre-defined
+!--       by user
           IF ( mg_switch_to_pe0_level == 0 )  THEN
+
              IF ( mg_switch_to_pe0_level_l /= 0 )  THEN
                 mg_switch_to_pe0_level = mg_switch_to_pe0_level_l
@@ -874,33 +697,28 @@
 !
 !--          Check pre-defined value and reset to default, if neccessary
-             IF ( mg_switch_to_pe0_level < mg_switch_to_pe0_level_l  .OR.                          &
+             IF ( mg_switch_to_pe0_level < mg_switch_to_pe0_level_l  .OR.  &
                   mg_switch_to_pe0_level >= maximum_grid_level_l )  THEN
-                message_string = 'mg_switch_to_pe0_level ' //                                      &
-                                 'out of range and reset to 0'
-                CALL message( 'init_pegrid', 'PA0235', 0, 1, 0, 6, 0 )
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ WARNING init_pegrid: mg_switch_to_pe0_level ', &
+                               'out of range and reset to default (=0)'
+                ENDIF
                 mg_switch_to_pe0_level = 0
              ELSE
 !
-!--             Use the largest number of possible levels anyway and recalculate the switch level to
-!--             this largest number of possible values
+!--             Use the largest number of possible levels anyway and recalculate
+!--             the switch level to this largest number of possible values
                 maximum_grid_level = maximum_grid_level_l
 
              ENDIF
-
-          ENDIF
-
-       ENDIF
-
-       ALLOCATE( grid_level_count(maximum_grid_level),                                             &
-                 nxl_mg(0:maximum_grid_level), nxr_mg(0:maximum_grid_level),                       &
-                 nyn_mg(0:maximum_grid_level), nys_mg(0:maximum_grid_level),                       &
-                 nzt_mg(0:maximum_grid_level) )
+          ENDIF
+
+       ENDIF
+
+       ALLOCATE( grid_level_count(maximum_grid_level),                   &
+                 nxl_mg(maximum_grid_level), nxr_mg(maximum_grid_level), &
+                 nyn_mg(maximum_grid_level), nys_mg(maximum_grid_level), &
+                 nzt_mg(maximum_grid_level) )
 
        grid_level_count = 0
-!
-!--    Index zero required as dummy due to definition of arrays f2 and p2 in recursive subroutine
-!--    next_mg_level
-       nxl_mg(0) = 0; nxr_mg(0) = 0; nyn_mg(0) = 0; nys_mg(0) = 0; nzt_mg(0) = 0
-
        nxl_l = nxl; nxr_l = nxr; nys_l = nys; nyn_l = nyn; nzt_l = nzt
 
@@ -910,5 +728,7 @@
 #if defined( __parallel )
 !
-!--          Save the grid size of the subdomain at the switch level, because it is needed in poismg.
+!--          Save the grid size of the subdomain at the switch level, because
+!--          it is needed in poismg.
+!--          Array bounds of the local subdomain grids are gathered on PE0
              ind(1) = nxl_l; ind(2) = nxr_l
              ind(3) = nys_l; ind(4) = nyn_l
@@ -924,5 +744,5 @@
              DEALLOCATE( ind_all )
 !
-!--          Calculate the grid size of the total domain
+!--          Calculate the grid size of the total domain gathered on PE0
              nxr_l = ( nxr_l-nxl_l+1 ) * pdims(1) - 1
              nxl_l = 0
@@ -930,16 +750,23 @@
              nys_l = 0
 !
-!--          The size of this gathered array must not be larger than the array tend, which is used
-!--          in the multigrid scheme as a temporary array. Therefore the subdomain size of an PE is
-!--          calculated and the size of the gathered grid. These values are used in routines pres
-!--          and poismg.
-             subdomain_size = ( nxr - nxl + 2 * nbgp + 1 ) *                                       &
-                              ( nyn - nys + 2 * nbgp + 1 ) * ( nzt - nzb + 2 )
-             gathered_size  = ( nxr_l - nxl_l + 3 ) * ( nyn_l - nys_l + 3 ) * ( nzt_l - nzb + 2 )
-
+!--          The size of this gathered array must not be larger than the
+!--          array tend, which is used in the multigrid scheme as a temporary
+!--          array
+             subdomain_size = ( nxr - nxl + 3 )     * ( nyn - nys + 3 )     * &
+                              ( nzt - nzb + 2 )
+             gathered_size  = ( nxr_l - nxl_l + 3 ) * ( nyn_l - nys_l + 3 ) * &
+                              ( nzt_l - nzb + 2 )
+
+             IF ( gathered_size > subdomain_size )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ init_pegrid: not enough memory for storing ', &
+                               'gathered multigrid data on PE0'
+                ENDIF
+                CALL local_stop
+             ENDIF
 #else
-             message_string = 'multigrid gather/scatter impossible ' //                            &
+             PRINT*, '+++ init_pegrid: multigrid gather/scatter impossible ', &
                           'in non parallel mode'
-             CALL message( 'init_pegrid', 'PA0237', 1, 2, 0, 6, 0 )
+             CALL local_stop
 #endif
           ENDIF
